//+------------------------------------------------------------------+
//|                                                  Force Index.mq4 |
//|                      Copyright  2005, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 DodgerBlue
#property indicator_level1 0.03
#property indicator_level2 -0.03
#property indicator_level3 0.05
#property indicator_level4 -0.05
#property indicator_levelcolor Gray
//---- input parameters
extern bool Alerts_On = true;
extern bool Alerts_EOB = true; // End of bar alerts
extern double Alert_Trigger_Level_1 = 0.03;
extern double Alert_Trigger_Level_2 = 0.05;

extern int ExtForcePeriod=13;
extern int ExtForceMAMethod=0;
extern int ExtForceAppliedPrice=0;

//---- buffers
double ExtForceBuffer[],ATL[3];
bool EntryAllowed[3];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string sShortName;
   SetIndexBuffer(0,ExtForceBuffer);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
//---- name for DataWindow and indicator subwindow label
   sShortName="Force("+ExtForcePeriod+")";
   IndicatorShortName(sShortName);
   SetIndexLabel(0,sShortName);
//---- first values aren't drawn
   SetIndexDrawBegin(0,ExtForcePeriod);
   
   ATL[1] = Alert_Trigger_Level_1;
   ATL[2] = Alert_Trigger_Level_2;
  
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Force Index indicator                                            |
//+------------------------------------------------------------------+
int start()
  {
   int nLimit;
   int nCountedBars=IndicatorCounted();
//---- insufficient data
   if(Bars<=ExtForcePeriod) return(0);
   else nCountedBars++;
   nLimit=Bars-nCountedBars;
//---- Force Index counted
   for(int i=nLimit; i>=0; i--)
   {
    ExtForceBuffer[i]=Volume[i]*(iMA(NULL,0,ExtForcePeriod,0,ExtForceMAMethod,ExtForceAppliedPrice,i)
                               -iMA(NULL,0,ExtForcePeriod,0,ExtForceMAMethod,ExtForceAppliedPrice,i+1));
    if (Alerts_On && i == Alerts_EOB) {
     for (int f=1; f<3; f++) {
      double TriggerLevel = ATL[f];
     if (MathAbs(ExtForceBuffer[i]) > TriggerLevel) {
      if (EntryAllowed[f]) {
       Alert("ForceIndex threshold ",f," exceeded... (",GetCurrentTF(Period())," ",Symbol(),")"); // alert by omelette
       EntryAllowed[f] = false; } }
     else EntryAllowed[f] = true; } }
   }
//---- done
   return(0);
  }
  
  string GetCurrentTF(int Prd)
  {
   string temp;
   
   switch(Prd) {
    case 1: temp = "M1"; break;
    case 5: temp = "M5"; break;
    case 15: temp = "M15"; break;
    case 30: temp = "M30"; break;
    case 60: temp = "H1"; break;
    case 240: temp = "H4"; break;
    case 1440: temp = "D1"; break;
    case 10080: temp = "W1"; break;
    case 43200: temp = "M1"; break; }
    
   return(temp);
   
   }
//+------------------------------------------------------------------+